import { ref } from 'vue';
import { defineStore } from 'pinia';
import Api from '@/api';
import { store } from '@/store';
const needCachedKey = [
  'contract_type', // 合同类型
];

export const useDictStore = defineStore('dict', () => {
  const dictTypes = ref<API.DictTypeDto[]>([]);
  const getDictTypes = async () => {
    dictTypes.value = await Api.systemDictType.dictTypeGetAll({
      storeCodes: needCachedKey,
      withItems: true,
    });
  };
  getDictTypes();
  const getDictItemsByCode = async (code: string): Promise<API.DictItemEntity[]> => {
    try {
      const dictType = dictTypes.value.find((item) => item.code === code);
      if (dictType) {
        return await Api.systemDictItem.dictItemGetAllByTypeId(dictType.id!);
      }
      return Promise.resolve([]);
    } catch (error) {
      return Promise.reject(error);
    }
  };

  return { dictTypes, getDictTypes, getDictItemsByCode };
});

// 在组件setup函数外使用
export function useDictStoreWithOut() {
  return useDictStore(store);
}
